## bifcl 1.1

=== debian/changelog ===
bifcl (1.1-1) unstable; urgency=medium

  * Initial release (Closes: #921560)

 -- Hilko Bengen <bengen@debian.org>  Wed, 06 Feb 2019 20:25:42 +0100

## bifcl 1.2+really+1.1

=== CMakeLists.txt ===
project(BifCl C CXX)

cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

include(cmake/CommonCMakeConfig.cmake)

include(FindRequiredPackage)

FindRequiredPackage(BISON)
FindRequiredPackage(FLEX)

if ( MISSING_PREREQS )
    foreach (prereq ${MISSING_PREREQ_DESCS})
        message(SEND_ERROR ${prereq})
    endforeach ()
    message(FATAL_ERROR "Configuration aborted due to missing prerequisites")
endif ()

include_directories(BEFORE
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
)

set(BISON_FLAGS "--debug")

# BIF parser/scanner
bison_target(BIFParser builtin-func.y
             ${CMAKE_CURRENT_BINARY_DIR}/bif_parse.cc
             HEADER ${CMAKE_CURRENT_BINARY_DIR}/bif_parse.h
             #VERBOSE ${CMAKE_CURRENT_BINARY_DIR}/bif_parse.output
             COMPILE_FLAGS "${BISON_FLAGS}")
flex_target(BIFScanner builtin-func.l ${CMAKE_CURRENT_BINARY_DIR}/bif_lex.cc)
add_flex_bison_dependency(BIFScanner BIFParser)
set_property(SOURCE bif_lex.cc APPEND_STRING PROPERTY COMPILE_FLAGS "-Wno-sign-compare")

set(bifcl_SRCS
   ${BISON_BIFParser_INPUT}
   ${FLEX_BIFScanner_INPUT}
   ${BISON_BIFParser_OUTPUTS}
   ${FLEX_BIFScanner_OUTPUTS}
   bif_arg.cc
   bif_arg.h
   module_util.cc
   module_util.h
)

add_executable(bifcl ${bifcl_SRCS})

install(TARGETS bifcl DESTINATION bin)

if (CMAKE_BUILD_TYPE)
    string(TOUPPER ${CMAKE_BUILD_TYPE} BuildType)
endif ()

message(
    "\n====================|  Bifcl Build Summary  |====================="
    "\n"
    "\nBuild type:        ${CMAKE_BUILD_TYPE}"
    "\nBuild dir:         ${CMAKE_BINARY_DIR}"
    "\nInstall prefix:    ${CMAKE_INSTALL_PREFIX}"
    "\nDebug mode:        ${ENABLE_DEBUG}"
    "\n"
    "\nCC:                ${CMAKE_C_COMPILER}"
    "\nCFLAGS:            ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${BuildType}}"
    "\nCXX:               ${CMAKE_CXX_COMPILER}"
    "\nCXXFLAGS:          ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${BuildType}}"
    "\nCPP:               ${CMAKE_CXX_COMPILER}"
    "\n"
    "\n================================================================\n"
)

include(UserChangedWarning)

=== Makefile ===
#
# A simple static wrapper for a number of standard Makefile targets,
# mostly just forwarding to build/Makefile. This is provided only for
# convenience and supports only a subset of what CMake's Makefile
# to offer. For more, execute that one directly. 
#

BUILD=build
REPO=$$(cd $(CURDIR) && basename $$(git config --get remote.origin.url | sed 's/^[^:]*://g'))
VERSION_FULL=$(REPO)-$$(cd $(CURDIR) && cat VERSION)
VERSION_MIN=$(REPO)-$$(cd $(CURDIR) && cat VERSION)-minimal
GITDIR=$$(test -f .git && echo $$(cut -d" " -f2 .git) || echo .git)

all: configured
	$(MAKE) -C $(BUILD) $@

install: configured
	$(MAKE) -C $(BUILD) $@

clean: configured
	$(MAKE) -C $(BUILD) $@

dist:
	@test -e ../$(VERSION_FULL) && rm -ri ../$(VERSION_FULL) || true
	@cp -R . ../$(VERSION_FULL)
	@for i in . $$(git submodule foreach -q --recursive realpath --relative-to=$$(pwd) .); do ((cd ../$(VERSION_FULL)/$$i && test -f .git && cp -R $(GITDIR) .gitnew && rm -f .git && mv .gitnew .git && sed -i.bak -e 's#[[:space:]]*worktree[[:space:]]*=[[:space:]]*.*##g' .git/config) || true); done
	@for i in . $$(git submodule foreach -q --recursive realpath --relative-to=$$(pwd) .); do (cd ../$(VERSION_FULL)/$$i && git reset -q --hard && git clean -ffdxq); done
	@(cd ../$(VERSION_FULL) && find . -name \.git\* | xargs rm -rf)
	@mv ../$(VERSION_FULL) .
	@tar -czf $(VERSION_FULL).tar.gz $(VERSION_FULL)
	@echo Package: $(VERSION_FULL).tar.gz
	@rm -rf $(VERSION_FULL)

distclean:
	rm -rf $(BUILD)

.PHONY : configured
configured:
	@test -d $(BUILD) || ( echo "Error: No build/ directory found. Did you run configure?" && exit 1 )
	@test -e $(BUILD)/Makefile || ( echo "Error: No build/Makefile found. Did you run configure?" && exit 1 )

=== debian/changelog ===
bifcl (1.2+really+1.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:10:44 +0100

bifcl (1.2+really+1.1-1) unstable; urgency=medium

  * Downgrade upstream version to 1.1 since the Bro build system
    so far expects bifcl to generate *.bro instead of *.zeek files.

 -- Hilko Bengen <bengen@debian.org>  Tue, 08 Oct 2019 11:10:24 +0200

bifcl (1.2-1) unstable; urgency=medium

  * New upstream version 1.2

 -- Hilko Bengen <bengen@debian.org>  Tue, 03 Sep 2019 23:52:24 +0200

=== debian/control ===
Source: bifcl
Section: devel
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 12~),
 cmake,
 bison, flex,
Standards-Version: 4.3.0
Homepage: https://www.zeek.org/
Vcs-Git: https://salsa.debian.org/bro-team/bifcl.git
Vcs-Browser: https://salsa.debian.org/bro-team/bifcl

Package: bifcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Bro Built-In-Function Compiler
 The bifcl program simply takes a .bif file as input and generates C++
 header/source files along with a .bro script that all-together
 provide the declaration and implementation of Bro Built-In-Functions
 (BIFs), which can then be compiled and shipped as part of a Bro
 plugin.
 .
 A BIF allows one to write arbitrary C++ code and access it via a
 function call inside a Bro script. In this way, they can also be used
 to access parts of Bro's internal C++ API that aren't already exposed
 via their own BIFs.

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
    https://www.bro.org/downloads/ bifcl-(\d.*)\.tar\.gz

## bifcl 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-project(BifCl C CXX)
 
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
+project(BifCl C CXX)
 
 include(cmake/CommonCMakeConfig.cmake)
 
@@ -16,8 +16,10 @@
     message(FATAL_ERROR "Configuration aborted due to missing prerequisites")
 endif ()
 
+include(RequireCXX17)
+
 include_directories(BEFORE
-                    ${CMAKE_CURRENT_SOURCE_DIR}
+                    ${CMAKE_CURRENT_SOURCE_DIR}/include
                     ${CMAKE_CURRENT_BINARY_DIR}
 )
 
@@ -39,9 +41,9 @@
    ${BISON_BIFParser_OUTPUTS}
    ${FLEX_BIFScanner_OUTPUTS}
    bif_arg.cc
-   bif_arg.h
+   include/bif_arg.h
    module_util.cc
-   module_util.h
+   include/module_util.h
 )
 
 add_executable(bifcl ${bifcl_SRCS})

=== debian/changelog ===
bifcl (1.4.0-1) unstable; urgency=medium

  * New upstream version 1.4.0
  * Update watch file

 -- Hilko Bengen <bengen@debian.org>  Fri, 11 Sep 2020 00:26:02 +0200

bifcl (1.2+rel-2) experimental; urgency=medium

  * Re-introduce upstream version 1.2

 -- Hilko Bengen <bengen@debian.org>  Sat, 15 Feb 2020 00:05:38 +0100

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
    https://download.zeek.org/ bifcl-(\d.*)\.tar\.gz

## bifcl 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
 project(BifCl C CXX)
 
 include(cmake/CommonCMakeConfig.cmake)
@@ -19,19 +19,19 @@
 include(RequireCXX17)
 
 include_directories(BEFORE
-                    ${CMAKE_CURRENT_SOURCE_DIR}/include
-                    ${CMAKE_CURRENT_BINARY_DIR}
+                    ${BifCl_SOURCE_DIR}/include
+                    ${BifCl_BINARY_DIR}
 )
 
 set(BISON_FLAGS "--debug")
 
 # BIF parser/scanner
 bison_target(BIFParser builtin-func.y
-             ${CMAKE_CURRENT_BINARY_DIR}/bif_parse.cc
-             HEADER ${CMAKE_CURRENT_BINARY_DIR}/bif_parse.h
-             #VERBOSE ${CMAKE_CURRENT_BINARY_DIR}/bif_parse.output
+             ${BifCl_BINARY_DIR}/bif_parse.cc
+             HEADER ${BifCl_BINARY_DIR}/bif_parse.h
+             #VERBOSE ${BifCl_BINARY_DIR}/bif_parse.output
              COMPILE_FLAGS "${BISON_FLAGS}")
-flex_target(BIFScanner builtin-func.l ${CMAKE_CURRENT_BINARY_DIR}/bif_lex.cc)
+flex_target(BIFScanner builtin-func.l ${BifCl_BINARY_DIR}/bif_lex.cc)
 add_flex_bison_dependency(BIFScanner BIFParser)
 set_property(SOURCE bif_lex.cc APPEND_STRING PROPERTY COMPILE_FLAGS "-Wno-sign-compare")
 
@@ -58,7 +58,7 @@
     "\n====================|  Bifcl Build Summary  |====================="
     "\n"
     "\nBuild type:        ${CMAKE_BUILD_TYPE}"
-    "\nBuild dir:         ${CMAKE_BINARY_DIR}"
+    "\nBuild dir:         ${PROJECT_BINARY_DIR}"
     "\nInstall prefix:    ${CMAKE_INSTALL_PREFIX}"
     "\nDebug mode:        ${ENABLE_DEBUG}"
     "\n"

=== debian/changelog ===
bifcl (1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0
  * Bump Debhelper compat level, Standards-Version

 -- Hilko Bengen <bengen@debian.org>  Mon, 27 Dec 2021 20:03:32 +0100

## bifcl 1.6.2

=== debian/changelog ===
bifcl (1.6.2-1) unstable; urgency=medium

  * New upstream version 1.6.2
  * Add debian/gbp.conf

 -- Hilko Bengen <bengen@debian.org>  Tue, 06 Dec 2022 20:23:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: devel
 Priority: optional
 Maintainer: Hilko Bengen <bengen@debian.org>
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (=13),
  cmake,
  bison, flex,
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0
 Homepage: https://www.zeek.org/
 Vcs-Git: https://salsa.debian.org/bro-team/bifcl.git
 Vcs-Browser: https://salsa.debian.org/bro-team/bifcl

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- -DBINARY_PACKAGING_MODE=1

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGES

%:
	dh $@ --buildsystem=cmake
